



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>React文档（二十一）协调</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">React文档（二十一）协调</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-22 03:54:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>React提供了一个声明式地API因此你不用担心每一次更新什么东西改变了。这使得开发应用变得简单，但是这个东西在React中如何实现的并不是很明显。这篇文章会解释我们在React的算法中所做的选择以便组件的更新是可预测的当为了高性能的app而变得速度足够快。</p>
<p><strong>目的</strong></p>
<p>当你使用React，在一个单独的时间点你可以考虑render()函数会创建一棵React元素的树。当下一次state或者props更新了，render()函数将会返回一个不同的树。React随后需要解决怎样有效率地更新UI去匹配最新的树。</p>
<p>对于这个最小化转变一个树到另一个树的操作的算法问题，这里有一些通用的解决办法。然而，树中元素个数为n，最先进的算法 的时间复杂度为O(n^3) 。</p>
<p>如果我们在React里使用这个算法，显示1000个元素将会要求按次序发生十亿次比较。这样的比较的花费太高昂了。React实现了一个探索式的O(n)算法基于两种假设：</p>
<ol><li>两个元素类型不同会造成不同的树</li>
<li>借助一个key属性，开发者可以暗示哪一个子元素在不同的渲染的时候会稳定不变</li></ol>
<p>实际上，这些假设几乎对所有实际使用场景都是有效的。</p>
<p><strong>对比算法</strong></p>
<p>当比较两棵树的时候，React首先比较两个根元素。根据根元素的type不同比较的行为也不同。</p>
<p>不同类型的元素</p>
<p>无论何时根元素如果有不同的类型，React会销毁旧的树然后从草稿中创建新的树。从&lt;a&gt;变成&lt;img&gt;，或者从&lt;Article&gt;变成&lt;Comment&gt;，或者从&lt;Button&gt;变成&lt;div&gt;，任何这样的改变都会使得整个树重建。</p>
<p>当销毁一个树的时候，旧的DOM节点就被销毁了。组件实例调用componentWillUnmount()方法。当创建了一个新的树，新的DOM节点被插入已有的DOM。组件实例依次调用componentWillMount()方法和之后的componentDidMount()方法。任何旧的树的state都会丢失。</p>
<p>任何根元素之下的组件也会被销毁并且state也丢失。举个例子，当比较不同的时候：</p>
<div>
<pre class="prettyprint linenums">&lt;div&gt;<br />
  &lt;Counter /&gt;<br />
&lt;/div&gt;

&lt;span&gt;<br />
  &lt;Counter /&gt;<br />
&lt;/span&gt;</pre>
</div>
<p>这样会销毁旧的Counter然后重新建立一个新的。</p>
<p>相同类型的DOM元素</p>
<p>当比较两个相同类型的React DOM元素的时候，React会观察它们的属性，保留相同的DOM节点，只更新改变了的属性。举个例子：</p>
<div>
<pre class="prettyprint linenums">&lt;div className="before" title="stuff" /&gt;

&lt;div className="after" title="stuff" /&gt;</pre>
</div>
<p>通过比较这两个元素，React知道只去修改className属性。</p>
<p>当更新style的时候，React也知道只去更新改变了的属性。举个例子：</p>
<div>
<pre class="prettyprint linenums">&lt;div style={{color: 'red', fontWeight: 'bold'}} /&gt;

&lt;div style={{color: 'green', fontWeight: 'bold'}} /&gt;</pre>
</div>
<p>当改变发生在这两个元素之间，React知道只去修改color样式，而不修改fontWeight。</p>
<p>在处理DOM节点之后，React之后会在子元素上递归计算。</p>
<p>相同类型的组件元素</p>
<p>当一个组件更新的时候，实例保持一样，以便渲染的时候state被维持。React更新底层组件实例的props去产生新元素，并且在底层实例上调用componentWillReceiveProps()和componentWillUpdate()。</p>
<p>接下来，render()方法被调用并且diff算法在之前的结果和新结果上递归处理。</p>
<p>子节点的递归</p>
<p>默认情况，当在DOM节点的子节点上递归时，React仅在同一时间点递归两个子节点列表，并在有不同时产生一个变更。</p>
<p>举个例子，当在子元素的结尾添加一个元素的时候，两个树之间的转变：</p>
<div>
<pre class="prettyprint linenums">&lt;ul&gt;<br />
  &lt;li&gt;first&lt;/li&gt;<br />
  &lt;li&gt;second&lt;/li&gt;<br />
&lt;/ul&gt;

&lt;ul&gt;<br />
  &lt;li&gt;first&lt;/li&gt;<br />
  &lt;li&gt;second&lt;/li&gt;<br />
  &lt;li&gt;third&lt;/li&gt;<br />
&lt;/ul&gt;</pre>
</div>
<p>React将会匹配两个&lt;li&gt;first&lt;/li&gt;树，匹配两个&lt;li&gt;second&lt;/li&gt;树，然后再插入&lt;li&gt;third&lt;/li&gt;树。</p>
<p>如果你很简单地实现它，在起始位置插入一个元素那样性能就会很差。举个例子，下面两个树的转变就不好：</p>
<div>
<pre class="prettyprint linenums">&lt;ul&gt;<br />
  &lt;li&gt;Duke&lt;/li&gt;<br />
  &lt;li&gt;Villanova&lt;/li&gt;<br />
&lt;/ul&gt;

&lt;ul&gt;<br />
  &lt;li&gt;Connecticut&lt;/li&gt;<br />
  &lt;li&gt;Duke&lt;/li&gt;<br />
  &lt;li&gt;Villanova&lt;/li&gt;<br />
&lt;/ul&gt;</pre>
</div>
<p>React会使每一个子元素变化而不是保持&lt;li&gt;Duke&lt;/li&gt;和&lt;li&gt;Villanova&lt;/li&gt;子树不变。这样的低效率会成为一个问题。</p>
<p><strong>key属性</strong></p>
<div>为了解决这个问题，React支持一个key属性。当一个子元素拥有key属性，React使用key来匹配原始的树和之后的新树。举个例子，添加一个key到我们上面那个效率低的例子里就可以让转换变得有效率：</div>
<div>
<div>
<pre class="prettyprint linenums">&lt;ul&gt;<br />
  &lt;li key="2015"&gt;Duke&lt;/li&gt;<br />
  &lt;li key="2016"&gt;Villanova&lt;/li&gt;<br />
&lt;/ul&gt;

&lt;ul&gt;<br />
  &lt;li key="2014"&gt;Connecticut&lt;/li&gt;<br />
  &lt;li key="2015"&gt;Duke&lt;/li&gt;<br />
  &lt;li key="2016"&gt;Villanova&lt;/li&gt;<br />
&lt;/ul&gt;</pre>
</div>
<p>现在React知道了拥有2014key的元素是新元素，而拥有2015和2016的元素只是需要移动一下位置。</p>
<p>事实上，找到一个key通常不麻烦。你将要去显示的元素也许已经有了一个唯一的ID，因此key属性也可以使用你的数据：</p>
<div>
<pre class="prettyprint linenums">&lt;li key={item.id}&gt;{item.name}&lt;/li&gt;</pre>
</div>
<p>如果不是这种情况，你可以添加新的ID属性到你的模型或者哈希一些内容来生成一个key。这个key对于兄弟元素必须唯一，但是不需要全局唯一。</p>
<p>万不得已，你可以传递它们在数组里的索引作为一个key。如果数组不会重新排序那么这样也会起作用，但是如果重新排序程序也会变慢。</p>
<p>当索引用作key时，组件状态在重新排序时也会有问题。组件实例基于key进行更新和重用。如果key是索引，则item的顺序变化会改变key值。这将导致受控组件的状态可能会以意想不到的方式混淆和更新。</p>
<p><a href="https://codepen.io/pen?&amp;editors=0010" rel="external nofollow noreferrer">这里</a>是在CodePen上使用索引作为键可能导致的问题的一个例子，<a href="https://codepen.io/pen?&amp;editors=0010" rel="external nofollow noreferrer">这里</a>是同一个例子的更新版本，展示了如何不使用索引作为键将解决这些reordering, sorting, 和 prepending的问题。</p>
<p><strong>权衡</strong></p>
<p>牢记协调算法的实现细节非常重要。React可能在每一次动作的时候会渲染整个app；最终的结果会是一样的。我们要定期地提炼这些启发式算法为了让相同的使用场景性能更好。</p>
<p>在如今的实现里，你可以表示这个事实，一个子树在它的兄弟节点之中移动，但是你不能告知它移动到哪里。算法将会渲染整个子树。</p>
<p>因为React依赖于启发式算法，如果在它们背后的设想没有被满足，那么性能会受损。</p>
<ol><li>这个算法不会去试图匹配组件类型不同的子树。如果你看到交替的两种组件类型有着相似的输出，你也许想要使它们的类型一样。事实上，我们还没有发现这样会出现问题。</li>
<li>key属性必须稳定，可预测还有唯一。不稳定的key（就像那些通过Math.random()生成的随机数）将会造成许多组件实例和DOM节点不必要的重复创建，这样就会使性能变差并且在子组件中丢失state。</li></ol>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m963zln9.html">原生js事件的添加和删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy4vxjq.html">yii2 model层中配置常量与list</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m50z2q.html">Windows 8&period;1 应用再出发 -  几种新增控件（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1pd3r9.html">基于tcpdump实例讲解TCP&sol;IP协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm702k9.html">StartUML破解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm7nll9.html">OSTaskCreateExt&lpar;&rpar;    建立任务</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv6k7xq.html">Rotate Array 解答</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m45req.html">php获取post参数的几种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj27x38.html">oracle&lowbar;plseq客户端中文乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkx3rv8.html">使用H2数据库进行单元测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjx73k8.html">Eureka配置instanceId显示IP</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gew4m78.html">WinForm -- 为TextBox文本框添加鼠标右键菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj70v28.html">RESTful api风格介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rkn008.html">Codeforces Round &num;552 &lpar;Div&period; 3&rpar; C题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1nzy49.html">mybatis的一些小知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj42j09.html">python&comma;random随机数的获取</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1g32pq.html">JSP&lpar;8&rpar;&mdash;EL案例和JSTL案例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1rp4lq.html">Sublime&lowbar;text编辑器插件安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m27yo0q.html">Codeforce  287A - IQ Test （模拟）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r0n628.html">TOJ 4976&colon; 新生数（深搜）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv1gl1zq.html">【003：使用SW4STM32不进入中断的原因】</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp62nvq.html">父网访问子网（校园网访问校园网IP路由器下的一台电脑）远程路由器下的电脑</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p6x648.html">Oarcle之单行函数（上）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp6mnxq.html">在sql中select的执行顺序</a>
			</li>
						<li><a href="https://www.batexi.com/a/95055we8.html">第一章 Python程序语言简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ddjoq.html">Sql语法注意事项</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5zzo4q.html">idea maven指定编译参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5zdpeq.html">&lbrack;Python&rsqb;基础教程（4）、Python 变量类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4e1le9.html">标定版制作（棋盘、圆点、aruco等）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r7mwm9.html">ARDUINO入门按键通信试验</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
